    PROGRAM f08jcfe

!      F08JCF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dstevd, f06ejf, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: norm
       INTEGER                         :: i, ifail, info, ldz, liwork, lwork, n
       CHARACTER (1)                   :: job
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: d(:), e(:), work(:), z(:,:)
       INTEGER, ALLOCATABLE            :: iwork(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F08JCF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       ldz = n
       liwork = 5*n + 3
       lwork = n*n + 4*n + 1
       ALLOCATE (d(n),e(n-1),work(lwork),z(ldz,n),iwork(liwork))

!      Read T from data file

       READ (nin,*) d(1:n)
       READ (nin,*) e(1:n-1)

       READ (nin,*) job

!      Calculate all the eigenvalues and eigenvectors of T
!      The NAG name equivalent of dstevd is f08jcf
       CALL dstevd(job,n,d,e,z,ldz,work,lwork,iwork,liwork,info)

       WRITE (nout,*)
       IF (info>0) THEN
          WRITE (nout,*) 'Failure to converge.'
       ELSE

!         Print eigenvalues and eigenvectors

          WRITE (nout,*) 'Eigenvalues'
          WRITE (nout,99999) d(1:n)
          WRITE (nout,*)
          FLUSH (nout)

!         Normalize the eigenvectors
          DO i = 1, n
             norm = f06ejf(n,z(1,i),1)
             IF (z(1,i)<0.0_nag_wp)  norm = -norm
             z(1:n,i) = z(1:n,i)/norm
          END DO

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('General',' ',n,n,z,ldz,'Eigenvectors',ifail)

       END IF

99999  FORMAT (3X,(8F8.4))
    END PROGRAM f08jcfe
